package edu.dhbw.concurrent;

public class Beispiel1a {

    public static void main(String[] args) {
        int anzahl = 300000;
        int worker = 13;
        int teilanzahl = anzahl / worker;
        if (anzahl % worker != 0) {
            teilanzahl++;
        }
        RunBsp1a[] th = new RunBsp1a[worker];
        for (int i = 0; i < worker; i++) {
            int low = i * teilanzahl;
            int up = (i + 1) * teilanzahl;
            up = Math.min(up, anzahl);
            th[i] = new RunBsp1a(i, low, up);
        }
        for (int i = 0; i < worker; i++) {
            th[i].start();
        }
        System.out.println("Threads started");
        double summe = 0.0;
        for (int i = 0; i < worker; i++) {
            try {
                th[i].join();
                summe += th[i].summe;
            } catch (InterruptedException e) {
                // e.printStackTrace();
            }
        }
        System.out.println("threads terminated, summe = " + summe);
        // System.exit(0);
    }
}

class RunBsp1a extends Thread {
    int lower;
    int upper;
    int id;
    double summe;

    public RunBsp1a(int i, int l, int u) {
        lower = l;
        upper = u;
        id = i;
    }

    public void run() {
        double s = 0.0;
        for (int i = lower; i < upper; i++) {
            s += Math.cos(i);
        }
        summe = s;
        System.out.println("Thread[" + id + "], anzahl = " + (upper - lower)
                + ", summe = " + s);
    }
}
