package edu.dhbw.concurrent;

public class Beispiel4 {

    public static void main(String[] args) {
        Semaphore sem = new Semaphore(10); // 0, 10
        int worker = 100;
        Thread[] th = new Thread[worker];
        for (int i = 0; i < worker; i++) {
            th[i] = new ThreadBsp4(i, sem);
            th[i].start();
        }
        System.out.println("Threads started");
        // sem.release();
        // sem.release();
        // sem.release();
        for (int i = 0; i < worker; i++) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }

    }
}

class ThreadBsp4 extends Thread {
    Semaphore sem;
    int i;

    public ThreadBsp4(int i, Semaphore s) {
        sem = s;
        this.i = i;
    }

    @Override
    public void run() {
        System.out.println("Thread " + i + " started");
        sem.aquire();
        System.out.println("Semaphore aquired in Thread " + i + ": " + sem);
        try {
            Thread.sleep((int) (Math.random() * 50));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        sem.release();
        System.out.println("Semaphore released in Thread " + i + ": " + sem);

    }
}
