package edu.dhbw.concurrent;

public class MatrixTrans extends Matrix {

    public MatrixTrans(double[][] v) {
        super(v);
    }

    public Matrix mult(Matrix B) {
        double[][] Bval = B.transpose().val;
        double[][] c = new double[val.length][Bval[0].length];
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < Bval[0].length; j++) {
                double s = 0.0;
                for (int k = 0; k < val[0].length; k++) {
                    s += val[i][k] * Bval[j][k];
                }
                c[i][j] = s;
            }
        }
        return new Matrix(c);
    }
}
