package edu.dhbw.pv;

import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class Aufgabe4 {
    public static void main(String[] args) {
        int anzahl = 1000;
        int tasks = 7;
        ExecutorService pool = Executors.newCachedThreadPool();
        //ExecutorService pool = Executors.newSingleThreadExecutor();
        Future<Double>[] res = new Future[tasks]; 
        for (int j = 0; j < tasks; j++) {
            res[j] = pool.submit( new Task4(anzahl) );
        }
        pool.shutdown();
        double summe = 0.0;
        for (int j = 0; j < tasks; j++) {
            try {
                summe += res[j].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        System.out.println("summe = " + summe);
        //pool.shutdown();
    }
}

class Task4 implements Callable<Double> {
    int anzahl;
    public Task4(int a) {
        anzahl =a;
    }
    public Double call() {
        double s = 0.0;
        System.out.println("start ");
        for (int i = 0; i < anzahl; i++) {
            s += Math.sin(i);
        }
        System.out.println("end, s = " + s);
        return new Double(s);
    }
}