package edu.dhbw.pv;

import mpi.MPI;
import mpi.Status;

public class Aufgabe7 {

    public static void main(String[] args) {
        MPI.Init(args);

        int size = MPI.COMM_WORLD.Size();
        int me = MPI.COMM_WORLD.Rank();
        System.out.println("Hallo! ich bin " + me + " von " + size);
        int[] puffer = new int[10];
        int summe = 0;
        if (me == 0) {
            System.out.println("Hier ist Nummer 0.");
            for (int i = 0; i < puffer.length; i++) {
                puffer[i] = i*i;
            }
            for (int i = 1; i < size; i++) {
                MPI.COMM_WORLD.Send(puffer, 0, puffer.length, MPI.INT, i, 99);
            }
        } else {
            MPI.COMM_WORLD.Recv(puffer, 0, puffer.length, MPI.INT, 0, 99);
            System.out.println("puffer von " + me + " empfangen");
            for (int i = 0; i < puffer.length; i++) {
                summe += puffer[i];
            }
            System.out.println("summe = " + summe + " in " + me);
        }
        if (me == 0) {
            summe = 0;
            for (int i = 1; i < size; i++) {
                Status stat = MPI.COMM_WORLD.Recv(puffer, 0, 1, MPI.INT, i, 99);
                System.out.println("stat = " + stat.Get_count(MPI.INT));
                summe += puffer[0];
            }
            System.out.println("total sum " + summe);
        } else {
            puffer[0] = summe;
            MPI.COMM_WORLD.Send(puffer, 0, 1, MPI.INT, 0, 99);
        }
        MPI.Finalize();
    }
}
