package edu.dhbw.pv;

public class TransposeMatrix extends Matrix {
    public TransposeMatrix(int n, int m) {
        super(n, m);
    }
    public TransposeMatrix(int n, int m, boolean u) {
        super(n, m, u);
    }
    public TransposeMatrix(double[][] v) {
        super(v);
    }
    public Matrix multiply(Matrix B) {
        Matrix ret = new Matrix(val.length, val[0].length);
        Matrix Bt = B.transpose(); 
        for (int i = 0; i < val.length; i++) {
            for (int j = 0; j < val[0].length; j++) {
                double s = 0.0;
                for (int k = 0; k < val[0].length ; k++) {
                    s += val[i][k] * Bt.val[j][k]; // ohne transposre k,j
                }
                ret.val[i][j] = s;
            }
        }
        return ret;
    }
}
