import java.io.BufferedReader;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

public class ObjectClient {
    public static final int PORT = 65000;
    static String host = "192.168.50.71"; //"localhost";
    public static void main(String[] args) {
        if (args.length > 0) {
            host = args[0];
        }
        try {
            Socket s = new Socket(host,PORT);
            System.out.println("connected to server " + s);
            ObjectChannel oc = new ObjectChannel(s); 
            while (true) {
                String m = (String) oc.receive(); //br.readLine();
                System.out.println("m: " + m);
                if ( m.length() == 0 ) {
                    break;
                }
            }
            oc.send("GET dateiname");
            oc.send("");
            //oc.flush();
            while (true) {
                try {
                    String m = (String) oc.receive(); //br.readLine();
                    System.out.println("m: " + m);
                } catch (EOFException e) {
                    break;
                }
            }
            oc.close();
            s.close();
            System.out.println("Client");
        } catch (UnknownHostException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.out.println("done");
    }

}
