package edu.dhbw.concurrent;

public class Beispiel1 {

    public static void main(String[] args) {
        int anzahl = 300000;
        int worker = 13;
        int teilanzahl = anzahl / worker;
        if (anzahl % worker != 0) {
            teilanzahl++;
        }
        Thread[] th = new Thread[worker];
        for (int i = 0; i < worker; i++) {
            int low = i * teilanzahl;
            int up = (i + 1) * teilanzahl;
            up = Math.min(up, anzahl);
            th[i] = new Thread(new RunBsp1(i, low, up));
        }
        for (int i = 0; i < worker; i++) {
            th[i].start();
        }
        System.out.println("Threads started");
        for (int i = 0; i < worker; i++) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                // e.printStackTrace();
            }
        }
        System.out.println("threads terminated.");
    }
}

class RunBsp1 implements Runnable {
    int lower;
    int upper;
    int id;

    public RunBsp1(int i, int l, int u) {
        lower = l;
        upper = u;
        id = i;
    }

    public void run() {
        double s = 0.0;
        for (int i = lower; i < upper; i++) {
            s += Math.cos(i);
        }
        System.out.println("Thread[" + id + "], anzahl = " + (upper - lower)
                + ", summe = " + s);
    }
}
