package edu.dhbw.pv;

import java.util.concurrent.Semaphore;

public class Uebung4 {

    public static void main(String[] args) {
        Semaphore sem = new Semaphore(1); 
        int anzahl = 10;
        Thread[] th = new Thread[anzahl];
        for (int i = 0; i < anzahl; i++ ) {
            th[i] = new U4Thread(i, sem);
            th[i].start();
        }
        System.out.println("threads started");
        for (int i= 0; i < anzahl; i++ ) {
            try {
                th[i].join();
            } catch (InterruptedException e) { 
                e.printStackTrace();
            }
        }
        System.out.println("threads ended");
    }
}

class U4Thread extends Thread{
    Semaphore sem;
    int i;
    public U4Thread(int i, Semaphore s) {
        sem = s;
        this.i = i;
    }
    public String toString() {
        return "U4Thread i=" + i + ", sem=" + sem;                   
    }
    public void run() {
        System.out.println("start " + toString());
        try {
            try {
                sem.acquire();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            double d = 0.0;
            for (int i = 0;i < 10; i++) {
                 d += Math.cos(i);
            }
        } finally {
          sem.release();
        }
        System.out.println("end   " + toString());
    }
} 