package edu.dhbw.pv;

public class Aufgabe2 {
    public static double globaleSumme = 0.0;
	public static void main(String[] args) {
		int N = 10000000;
		int t = 10;
		Semaphore sem = new Semaphore(3);
		Thread[] threads = new Thread[t];
		Summe2[] sums = new Summe2[t];
		for (int i = 0; i < t; i++) {
			sums[i] = new Summe2(N, i, t, sem);
			threads[i] = new Thread(sums[i] );
			threads[i].start();
		}
		for (int i = 0; i < t; i++){ 
			try {
				threads[i].join();
				globaleSumme += sums[i].summe;
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		System.out.println("Summe = " + globaleSumme);
	}
	
}

class Summe2 implements Runnable {
	int thread;
	int noThreads;
	int N;
	double summe = 0.0;
	Semaphore sema;
	public Summe2(int n, int th, int nt, Semaphore sem) {
		sema = sem;
		N = n;
		thread = th;
		noThreads = nt;
	}
	public void run() {
		System.out.println("started thread " + thread + " of " + noThreads);
		//double summe = 0.0;
		try {
			sema.aquire();
			System.out.println("aquired in " + thread);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		for (int i = thread; i < N; i += noThreads) {
			summe += Math.sin(2.0*i);
		}
		sema.release();
		System.out.println("ended thread " + thread + ", lokale summe = " + summe);
	}
}
