import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.net.UnknownHostException;

public class ByteClient {
    public static final int PORT = 65000;
    static String host = "localhost";
    public static void main(String[] args) {
        if (args.length > 0) {
            host = args[0];
        }
        try {
            Socket s = new Socket(host,PORT);
            System.out.println("connected to server " + s);
            BufferedReader br = new BufferedReader(
                                                   new InputStreamReader(s.getInputStream()));
            PrintWriter pw = new PrintWriter(
                                             new OutputStreamWriter(s.getOutputStream()));
            while (true) {
                String m = br.readLine();
                System.out.println("m: " + m);
                if ( m.length() == 0 ) {
                    break;
                }
            }
            pw.println("GET dateiname");
            pw.println("");
            pw.flush();
            while (true) {
                String m = br.readLine();
                System.out.println("m: " + m);
                if ( m == null) {
                    break;
                }
            }
            pw.close();
            br.close();
            s.close();
        } catch (UnknownHostException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

}
