/**
  * Vector Scalar Multiplication Interface.
  * @author Heinz Kredel.
  */
public interface VSMInf {

/**
 * Computes the scalar multiplication of two vectors.
 * @param A Vector.
 * @param B Vector.
 */
    public double multiply(double[] A, double[] B);

/**
 * Computes the norm of a vector.
 * @param A norm.
 */
    public double norm(double[] A);

}
