package edu.dhbw.pv;

public class Uebung1 {
    static double globaleSumme = 0.0;
    public static void main(String[] args) {
        int anzahl = 1000; 
        Thread[] ths = new Thread[anzahl];
        long t = System.currentTimeMillis();
        for (int j = 0; j < anzahl; j++) {
            ths[j] = new Thread( new Summe1(j) );
            ths[j].start();
        }
        for (int j = 0;j < anzahl; j++ ) {
            try {
                ths[j].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }   
        }
        System.out.println("globaleSumme  " + globaleSumme);
        t = System.currentTimeMillis() - t;
        System.out.println("time = " + t);
        System.exit(0);
    }

}
class Summe1 implements Runnable {
    int j = 0;
    public Summe1(int jj) {
        j = jj;
    }
    public void run() {
        System.out.println("Thread " + j);
        double sum = 0.0;
        for (int i = 0; i< 1000; i++) {
            //synchronized(Uebung1.class) { nicht gut
            sum += Math.cos(i+j);
            //}
        }
        synchronized(Uebung1.class) { 
            Uebung1.globaleSumme += sum;
        }
        System.out.println("sum(" +j+ ") = " + sum);
    }
}

