package edu.dhbw.pv;

public class Uebung3 {
    public static void main(String[] args) {
        int n = 1000;
        int m = n;
        Matrix A = new Matrix( Matrix.random(n,m) );
        Matrix B = new Matrix( Matrix.one(n, m) );
        //System.out.println("A = \n" + A);
        //System.out.println("B = \n" + B);
        Matrix C = new Matrix( Matrix.zero(n, m) );
        long t = System.currentTimeMillis();
        C.multiply(C, A, B);
        t = System.currentTimeMillis() - t;
        //System.out.println("C = \n" + C);
        
        ParallelMatrix Cp = new ParallelMatrix(Matrix.zero(n,m));
        long tp = System.currentTimeMillis();
        Cp.multiply(Cp, A, B);
        tp = System.currentTimeMillis() - tp;
        
        MatrixTrans Ct = new MatrixTrans( Matrix.zero(n, m));
        long tt = System.currentTimeMillis();
        Ct.multiply(Ct, A, B);
        tt = System.currentTimeMillis() - tt;

        ParallelMatrixTrans Cpt = new ParallelMatrixTrans( Matrix.zero(n, m));
        long tpt = System.currentTimeMillis();
        Cpt.multiply(Cpt, A, B);
        tpt = System.currentTimeMillis() - tpt;
    
        System.out.println("A == C: " + A.equals(C));
        System.out.println("C == Cp: " + C.equals(Cp));
        System.out.println("sequenziell " + t);
        System.out.println("parallel    " + tp);
        System.out.println("seq transp  " + tt);
        System.out.println("par transp  " + tpt);
        /*
     n = 1500, 6 x 2 cores
     [java] A == C: true
     [java] C == Cp: true
     [java] sequenziell 17189
     [java] parallel    4859
     [java] seq transp  3015
     [java] par transp  1061

     n = 1000, 6 x 2 cores
     [java] A == C: true
     [java] C == Cp: true
     [java] sequenziell 2777
     [java] parallel    1106
     [java] seq transp  888
     [java] par transp  1012
	 */
    }
}
