package edu.dhbw.pv;

import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class Uebung5 {
    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        int anzahl = 100;
        ExecutorService pool = Executors.newFixedThreadPool(3);
        Future<Double>[] zukunft = new Future[anzahl];
        for (int i = 0; i < anzahl; i++) {
            zukunft[i] = pool.submit( new Summe5(i) );
        }
        double summe = 0.0;
        for (int i =0; i < anzahl; i++) { // anzahl/2
            double s = 0.0;
            try {
                s = zukunft[i].get();// blockiert
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
            summe += s;
        }
        System.out.println("globale Summe = " + summe);
        //pool.shutdown();
        List<Runnable> rest = pool.shutdownNow();
        System.out.println("rest = " + rest);
    }

}
class Summe5 implements Callable<Double> {
    int j = 0;
    public Summe5(int i) {
        j = i;
    }
    public Double call() {
        System.out.println("Thread " + j);
        double sum = 0.0;
        for (int i = 0; i< 1000; i++) {
            sum += Math.cos(i+j);
        }
        System.out.println("sum(" +j+ ") = " + sum);
        return sum;
    }
}