package edu.dhbw.pv; 

import mpi.MPI;

public class Uebung8 {
    public static void main(String[] args) {
        MPI.Init(args);
        int me = MPI.COMM_WORLD.Rank();
        int size =MPI.COMM_WORLD.Size();
        System.out.println("Hallo von " + me + " von " + size);
        int anzahl = 100;
        int[] zahlen = new int[anzahl];
        if (me == 0) {
            for (int i = 0; i < anzahl; i++) { 
                zahlen[i] = i;
            }
            for (int j = 1; j < size; j++) {
                MPI.COMM_WORLD.Send(zahlen, 0, anzahl, MPI.INT, j, 99);
            }
            System.out.println("alle zahlen von 0 versendet");
        } else {
            MPI.COMM_WORLD.Recv(zahlen, 0, anzahl, MPI.INT, 0, 99);
            System.out.println("zahlen von " + me + " empfangen");
        }
        int quadrat = 0; 
        for (int i = 0; i < zahlen.length; i++) {
            quadrat += zahlen[i]*zahlen[i] + me*me;
        }
        System.out.println("quadrat von " + me + " ist " + quadrat);
        if (me == 0) {
            int summe = quadrat;
            for (int j = 1; j < size; j++) {
                MPI.COMM_WORLD.Recv(zahlen, 0, 1, MPI.INT, j, 99);
                summe += zahlen[0];
            }
            System.out.println("summe = " + summe);
        } else {
            zahlen[0] = quadrat;
            MPI.COMM_WORLD.Send(zahlen, 0, 1, MPI.INT, 0, 99);
        }
        MPI.Finalize();
    }
}

