package edu.dhbw.pv; 

import mpi.MPI;

public class Uebung9 {
    public static void main(String[] args) {
        MPI.Init(args);
        int me = MPI.COMM_WORLD.Rank();
        int size =MPI.COMM_WORLD.Size();
        System.out.println("Hallo von " + me + " von " + size);
        int anzahl = 100;
        int[] zahlen = new int[anzahl];
        if (me == 0) {
            for (int i = 0; i < anzahl; i++) { 
                zahlen[i] = i;
            }
        }
        MPI.COMM_WORLD.Bcast(zahlen, 0, anzahl, MPI.INT, 0);
        System.out.println("alle zahlen versendet und empfangen " + me);
        int quadrat = 0; 
        for (int i = 0; i < zahlen.length; i++) {
            quadrat += zahlen[i]*zahlen[i] + me*me;
        }
        zahlen[0] = quadrat;
        System.out.println("quadrat von " + me + " ist " + quadrat);
        int [] zempf = new int[1];
        zempf[0] = -1;
        MPI.COMM_WORLD.Reduce(zahlen, 0, zempf, 0, 1, MPI.INT, MPI.SUM, 0);
        System.out.println("alle zahlen versendet, summiert und empfangen " + me);
        if (me == 0) {
            int summe = zempf[0];
            System.out.println("summe = " + summe);
        }
        MPI.Finalize();
    }
}

